/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  -----------------------------
  Terminal-Emulation fuer Linux
  -----------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <termios.h>
#include <errno.h>
#include <unistd.h>
#include "term_l.h"

int sock;            /* connected socket descriptor */
struct hostent *hp;  /* pointer to host info for remote host */
struct servent *sp;  /* pointer to service information */
long timevar;        /* contains time returned by time() */
char *ctime();       /* declare time formatting routine */
struct sockaddr_in myaddr_in;   /* for local socket address */
struct sockaddr_in peeraddr_in; /* for peer socket address */


#define TXLEN 256
#define RXLEN 256

char rxbuf[TXLEN];
char txbuf[RXLEN];
int rxc;
int txc;
int wasput;
int wasda;
char dasda;

void putflush_sock(void)
{
  if(txc)
  {
    while(1)
    { if(send(sock,txbuf,txc,0)==txc)
        break;
      if(errno!=EWOULDBLOCK)
        endmessage("%s",strerror(errno));
    }
    txc=0;
  }
}

void putv_sock(int c)
{
  txbuf[txc++]=c;
  wasput=1;
  if(txc>=TXLEN)
    putflush_sock();
}

char sock_buffer[1024];
int si;
int so;

int holsock(void)
{
  if(si>so)
    return sock_buffer[so++];
  so=si=0;
  if((si=recv(sock,sock_buffer,1024,0))<0)
  {
    if(errno==ENOTCONN || errno==EBADF)
      endmessage("receive: %s",strerror(errno));
  }
  else
  { if(si==0)
      endmessage("Connection closed by foreign host.");
  }
  return EOF;
}

void init_sock(char *host)
{
  char msg[80];
  unsigned int addrlen;

  memset ((char *)&myaddr_in, 0, sizeof(struct sockaddr_in));
  memset ((char *)&peeraddr_in, 0, sizeof(struct sockaddr_in));

  peeraddr_in.sin_family = AF_INET;
  hp = gethostbyname (host);
  if (hp == NULL)
    endmessage("%s not found in /etc/hosts",host);
  peeraddr_in.sin_addr.s_addr = ((struct in_addr *)(hp->h_addr))->s_addr;

  sp = getservbyname ("bcm", "tcp");
  if (sp == NULL)
    peeraddr_in.sin_port = htons (4719);
  else
    peeraddr_in.sin_port = sp->s_port;

  sock = socket (AF_INET, SOCK_STREAM, 0);
  if (sock == -1)
    endmessage("socket: %s",strerror(errno));
  if (connect(sock,(struct sockaddr *) &peeraddr_in,
      sizeof(struct sockaddr_in)) == -1)
    endmessage("connect: %s",strerror(errno));
  addrlen = sizeof(struct sockaddr_in);
  if (getsockname(sock,(struct sockaddr *) &myaddr_in, &addrlen) == -1)
    endmessage("getsockname: %s",strerror(errno));
  sprintf(msg,"OpenBCM BCT "VNUMMER": Mailbox at %s:%u on port %u",
              host,ntohs(peeraddr_in.sin_port), ntohs(myaddr_in.sin_port));
  statst(2,msg);

  if(fcntl(sock,F_SETFL,O_NONBLOCK)<0)
    endmessage("fcntl: %s",strerror(errno));
}

